//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////

#include "scene.h"

static inline void Kocka(float s)
{
	glBegin(GL_QUADS);
		// Front Face
		glNormal3f( 0.0f, 0.0f, 1.0f);		//normalovy vektor pre prednu stenu
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-s, -s,  s);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( s, -s,  s);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( s,  s,  s);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-s,  s,  s);
		// Back Face
		glNormal3f( 0.0f, 0.0f,-1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-s, -s, -s);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-s,  s, -s);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( s,  s, -s);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( s, -s, -s);
		// Top Face
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-s,  s, -s);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-s,  s,  s);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( s,  s,  s);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( s,  s, -s);
		// Bottom Face
		glNormal3f( 0.0f,-1.0f, 0.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-s, -s, -s);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( s, -s, -s);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( s, -s,  s);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-s, -s,  s);
		// Right face
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( s, -s, -s);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( s,  s, -s);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( s,  s,  s);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( s, -s,  s);
		// Left Face
		glNormal3f(-1.0f, 0.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-s, -s, -s);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-s, -s,  s);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-s,  s,  s);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-s,  s, -s);
	glEnd();
}

void Normalise(XYZ *p)
{
	float length;

	length = (float) sqrt(p->x * p->x + p->y * p->y + p->z * p->z);
	if (length != 0) {
		p->x /= length;
		p->y /= length;
		p->z /= length;
	} else {
		p->x = 0;
		p->y = 0;
		p->z = 0;
	}
}

void Gula_textur_v_svetlo_1_textura(float gula_polomer,int delenie_guli_sirka,int delenie_guli_dlzka)
{
	float	sirka;		// sirka je vo zvislom smere, moze byt severna, alebo juzna
	float	dlzka;		// dlzka je vo vodorovnom smere, moze byt vychodna, alebo zapadna
	int		i_sirka, i_dlzka;	// index sirky a dlzky
	float	u,v0,v1;		// suradnice na texture
	XYZ		b[2],normal;	// suradnice vypocitanych bodov
	double	velkost_casti_sirky,velkost_casti_dlzky;
	double	polomer_pre_sirku0,polomer_pre_sirku1;	// polomer pre danu sirku

	velkost_casti_sirky = 1.0/(double)delenie_guli_sirka;
	velkost_casti_dlzky = 1.0/(double)delenie_guli_dlzka;
	
	for(i_sirka=-delenie_guli_sirka; i_sirka<delenie_guli_sirka; i_sirka++) // ideme od 0 stupnov do < ako 90.0
	{
		sirka = (float)( i_sirka*90.0*velkost_casti_sirky );	// vypocet uhlu pre dany index
		v0 = (float)(0.5*(i_sirka+delenie_guli_sirka)*velkost_casti_sirky);			// vypocet prislusnej texturovej koordinacie
		v1 = (float)(0.5*(i_sirka+delenie_guli_sirka+1)*velkost_casti_sirky);		// dalsia texturova koordinacia

		polomer_pre_sirku0 = gula_polomer*cos(PI180*sirka);
		polomer_pre_sirku1 = gula_polomer*cos(PI180*(sirka+90.0*velkost_casti_sirky));
		b[0].y = (float)( gula_polomer*sin(PI180*sirka) );
		b[1].y = (float)( gula_polomer*sin(PI180*(sirka+90.0*velkost_casti_sirky)) );

		b[0].x = 0.0f;
		b[1].x = 0.0f;

		b[0].z = (float)( polomer_pre_sirku0 );
		b[1].z = (float)( polomer_pre_sirku1 );
		u = 0.0;								// vypocet prislusnej texturovej koordinacie

		glBegin( GL_TRIANGLE_STRIP);			// kreslim pas trojuholnikov
		
		normal = b[0];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v0);
		glVertex3fv((float*)&b[0]);
		
		normal = b[1];
		Normalise( &normal);
		glNormal3fv((float*)&normal);
		glTexCoord2f(u,v1);
		glVertex3fv((float*)&b[1]);

		for(i_dlzka=1; i_dlzka<=delenie_guli_dlzka; i_dlzka++) // ideme od o jeden viac ako 0 stupnov po 90.0
		{
			dlzka = (float)( i_dlzka*360.0*velkost_casti_dlzky );	// vypocet uhlu pre dany index
			u = (float)( i_dlzka*velkost_casti_dlzky );				// vypocet prislusnej texturovej koordinacie

			b[0].x = (float)( polomer_pre_sirku0*sin(PI180*dlzka) );
			b[1].x = (float)( polomer_pre_sirku1*sin(PI180*dlzka) );

			b[0].z = (float)( polomer_pre_sirku0*cos(PI180*dlzka) );
			b[1].z = (float)( polomer_pre_sirku1*cos(PI180*dlzka) );

			normal = b[0];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v0);
			glVertex3fv((float*)&b[0]);
			
			normal = b[1];
			Normalise( &normal);
			glNormal3fv((float*)&normal);
			glTexCoord2f(u,v1);
			glVertex3fv((float*)&b[1]);
		}
		glEnd();
	}
}


//////////////////////////////////////////////////////////////////////
// Tu je vsetko co sa kresli
float rot_y=0,rot_x=0;;
int size=256;
float t;

void scene::DrawGLScene()
{
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }
	if(svetlo)glEnable(GL_LIGHTING);			// zapne svetlo

	if(keys['P']){	ciary = !ciary;	keys['P']=0; }
		
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	if		(keys['1'])size=2;
	else if	(keys['2'])size=4;
	else if	(keys['3'])size=8;
	else if	(keys['4'])size=16;
	else if	(keys['5'])size=32;
	else if	(keys['6'])size=64;
	else if	(keys['7'])size=128;
	else if	(keys['8'])size=256;
	else if	(keys['9'])size=512;
	else if	(keys['0'])size=1;

	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	gluPerspective(uhol_kamery,1,blizka_orezavacia_rovina,vzdialena_orezavacia_rovina);
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();

	glViewport(0, 0, size, size);
	glClearColor(0.0f,0.0f,0.4f,0.0f);
 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();

	glBindTexture(GL_TEXTURE_2D,tex[0]);
	
	glTranslatef(0,0,-35);
	glRotatef(10.f*rot_y,0,1,0);
	rot_x+=5.f/fps;
	rot_y+=9.f/fps;
	if(rot_y>360.f)rot_y-=360.f;
	if(rot_x>360.f)rot_x-=360.f;
	Gula_textur_v_svetlo_1_textura(10.f,10,20);

	glBindTexture(GL_TEXTURE_2D,tex[1]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	timer1.Reset();
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, size, size, 0);
	t = timer1.GetTime();

	glViewport(0, 0, screen_x, screen_y);
	
	glClearColor(0.0f,0.0f,0.0f,0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	
	Prepni_do_3D();
	glTranslatef(0,0,-45);
	glRotatef(rot_x,1,0,0);
	glRotatef(rot_y,0,1,0);
	glRotatef(180,0,1,0);
	Kocka(10.0f);	

	Prepni_do_2D();
	glDisable(GL_LIGHTING);					// vypnutie osvetlenia
	if(keys['T'])
	{
		glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(10,10);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(10+size,10);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(10+size,10+size);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(10,10+size);
		glEnd();
	}

/*	
	GetCursorPos(&MouseBod);
	mouse_x = MouseBod.x;
	mouse_y = screen_y-1-MouseBod.y;
	
	 glColor4f(1,1,1,1);
	glLoadIdentity();
	glDisable(GL_TEXTURE_2D);
	Kurzor();
	glEnable(GL_TEXTURE_2D);
*/	
	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);
	
	gcvt( (double)t*1000.f, 4, text);		// prevod realneho cisla na text
	strcat(text," ms");
	font0->Print(0,1,text,0);
	
	gcvt( (double)size, 4, text);		// prevod realneho cisla na text
	font0->Print(0,2,text,0);

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.6f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(80,400);
			glVertex2i(800,400);
			glVertex2i(800,555);
			glVertex2i(80,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Render to texture",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(15,i++,"P - on/off wire frame",1);
			font0->Print(15,i++,"L - on/off lighting",1);
			font0->Print(15,i++,"T - show maked texture",1);
			font0->Print(15,i++,"0,1,..,9 - set size of texture on 2^key",1);
			
			font0->Print(15,i++,"1. row - FPS",1);
			font0->Print(15,i++,"2. row - time to copy screen to texture",1);
			font0->Print(15,i++,"3. row - size of texture",1);
		}
		else
		{
			font0->Print(15,i++,"Program: Kreslenie do textury - render to texture",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(15,i++,"P - zapne/vypne zobrazovanie ciar",1);
			font0->Print(15,i++,"L - zapne/vypne svetlo",1);
			font0->Print(15,i++,"T - zobrazy vytvorenu texturu",1);
			font0->Print(15,i++,"0,1,..,9 - nastavuje velkost textury na 2^klavesu",1);
			
			font0->Print(15,i++,"1. riadok - FPS",1);
			font0->Print(15,i++,"2. riadok - cas potrebny na skopirovanie do textury",1);
			font0->Print(15,i++,"3. riadok - velkost textury",1);
		}

		font0->Print(15,i++,"H - help",1);
	}
	font0->End();

}